<?php



namespace HelloPrint\Inc\Services;

class ProductPriceService
{

    public function getProductPriceMargin($product_id, $price)
    {
        $product_margin = $this->getProductMargin($product_id);
        $markup = (100 - (float)$product_margin) / 100;
        return ($markup > 0) ? round((float)$price / $markup) : round($price);
        //return round((($product_margin + 100) / 100) * $price);
    }

    public function getProductMargin($product_id)
    {
        $product_margin_option = get_post_meta($product_id, 'helloprint_product_margin_option', true);
        if (empty($product_margin_option)) {
            $product_margin_option = 0;
        }
        $product_margin_option = (int)$product_margin_option;
        if ($product_margin_option == 0) {
            $product_margin = get_post_meta($product_id, 'helloprint_product_margin', true);
        } else {
            $product_margin = $this->getGlobalMargin();
        }
        return (float)$product_margin;
    }

    public function getGlobalMargin()
    {
        $margin = get_option('helloprint_global_product_margin', true);
        if (empty($margin) || $margin == '' || $margin == null) {
            $margin = 0;
        }
        return $margin;
    }
}
