<?php
/**
* PHP view.
*
*/
?>
<div class="wrap">
    <h1><?php echo wp_kses(_translate_helloprint('Edit Print-on-Demand Preset', "helloprint"), true) ?></h1>
    <form enctype="multipart/form-data" name="helloprint-add-pod" method="POST" action="">
        <input type="hidden" name="action" value="update">
        <input type="hidden" name="id" value="<?php echo esc_attr($id);?>">

        <table class="form-table" role="presentation">
            <tbody>
                <tr class="example-class">
                    <th scope="row">
                        <label for="helloprint_api_key"><?php echo wp_kses(_translate_helloprint('Preset Name*', "helloprint"), true) ?></label>
                    </th>
                    <td>
                        <div class="example-class">
                         <input type="text" class="regular-text" id="order_preset_name" name="order_preset_name" value="<?php echo esc_attr($order_preset_name);?>" required="required" >
                     </div>
                 </td>
             </tr>
             <tr class="example-class">
                <th scope="row">
                    <label for="helloprint_api_key"><?php echo wp_kses(_translate_helloprint('Item SKU', "helloprint"), true) ?></label>
                </th>
                <td>
                    <div class="example-class">
                     <input type="text" class="regular-text" id="helloprint_item_sku" name="helloprint_item_sku" value="<?php echo esc_attr($helloprint_item_sku);?>">
                 </div>
             </td>
         </tr>
         <tr class="example-class">
            <th scope="row">
                <label for="helloprint_api_key"><?php echo wp_kses(_translate_helloprint('Helloprint Variant Key*', "helloprint"), true) ?></label>
            </th>
            <td>
                <div class="example-class">
                 <input type="text" class="regular-text" id="helloprint_order_preset_variant_key" name="helloprint_variant_key" value="<?php echo esc_attr($helloprint_variant_key);?>" required="required" >
             </div>
         </td>
     </tr>
     <tr class="example-class">
        <th scope="row">
            <label for="helloprint_api_key"><?php echo wp_kses(_translate_helloprint('Default Service Level', "helloprint"), true) ?></label>
        </th>
        <td>
            <div class="example-class">
             <select style="" id="helloprint_preset_default_service_level" name="default_service_level" class="select short helloprint-select2" >
                <?php if(!empty($default_service_level)):?>
                    <option value="<?php echo esc_attr($default_service_level);?>" selected><?php echo esc_attr(ucwords($default_service_level));?></option>
                <?php else:?>
                    <option value=""><?php echo wp_kses(_translate_helloprint('Select Service Level', "helloprint"), false) ?></option>
                <?php endif;?>
            </select>
        </div>
    </td>
</tr>

<tr class="example-class">
    <th scope="row">
        <label for="helloprint_api_key"><?php echo wp_kses(_translate_helloprint('Default Quantity', "helloprint"), true) ?></label>
    </th>
    <td>
        <div class="example-class">
         <select style="" id="helloprint_preset_default_quantity" name="default_quantity" class="select short helloprint-select2" >
            <option value=""><?php echo wp_kses(_translate_helloprint('Select Quantity', "helloprint"), false) ?></option>
            <?php if(!empty($default_quantity)):?>
                <option value="<?php echo esc_attr($default_quantity);?>" selected><?php echo esc_attr($default_quantity);?></option>
            <?php endif;?>

        </select>
    </div>
</td>
</tr>

<tr class="example-class">
    <th scope="row">
        <label for="helloprint_api_key"><?php echo wp_kses(_translate_helloprint('Print File', "helloprint"), true) ?></label>
    </th>
    <td>
        <div class="example-class">
           <div class="helloprint-order-preset-file-upload">
            <?php if(!empty($file_name)):?>
                <div class="helloprint-preset-file-remove-div">
                    <span><?php echo esc_attr($file_name);?></span>
                    <br/>
                    <a target="_blank" href="<?php echo esc_url_raw(get_site_url() . $file_url) ?>" class="btn-sm btn-outline-primary"><?php echo wp_kses(_translate_helloprint("Download", "helloprint"), true);?></a>&nbsp;&nbsp;&nbsp;&nbsp; | &nbsp;&nbsp;&nbsp;&nbsp;
                    <a href="#" class="helloprint-admin-preset-remove btn btn-sm btn-outline-danger"><?php echo wp_kses(_translate_helloprint("Remove", "helloprint"), true);?></a>
                </div>
            <?php endif;?>
            
            <div id="helloprint_order_preset_file"></div>
            <input type="file" class="helloprint_order_preset_file" name="helloprint_order_preset_file_upload" >
        </div> 
    </div>
</td>
</tr>
</tbody>
</table>
<p class="submit"><input type="submit" name="submit" id="submit" class="button button-primary" value="<?php echo wp_kses(_translate_helloprint('Save', "helloprint"), false) ?>"> <?php echo wp_kses(_translate_helloprint('* required', "helloprint"), true) ?></p>    
</form>
</div>